global subHiliteCast, SubTextCast, SubTextSprite, subHiliteSprite, subLeft, subTop, subMenuHierarchy, subOpenCast, subClosedCast, subMenuMaxLines, subTextHeight, subHelpBoxCast, subHelpBoxText, subBallCast

on activateWindow
  global FindWindow
  if objectp(FindWindow) then
    if the visible of FindWindow = 1 then
      set the visible of FindWindow to 0
    end if
  end if
end

on initSubGlobals winLeft, winTop
  set subLeft to winLeft
  set subTop to winTop
  set subHiliteCast to the number of member "Black Hilite Bar"
  set subBallCast to the number of member "turnedDown"
  set subHiliteSprite to 2
  set SubTextCast to the number of member "SubMenu"
  set SubTextSprite to 3
  set subMenuHierarchy to []
  set subMenuMaxLines to 23
  set subTextHeight to 14
  set subHelpBoxCast to the number of member "HelpBoxBig"
  set subHelpBoxText to the number of member "Status Bar"
end

on doMenu theText
  stuffMenu(theText)
  fixMenu()
end

on checkMouseWithin
  if the mouseCast = SubTextCast then
    mouseWithin(script SubTextCast)
  end if
end

on fixMenu
  set numLines to the number of lines in field "SubMenuOff"
  set menuText to the text of field "SubMenuOff"
  repeat with i = 1 to numLines
    set tempLine to line i of menuText
    set charsOver to offset("+", tempLine)
    set theMarkNum to i + 3
    if charsOver > 0 then
      set indentNum to charsOver / 3
      puppetSprite(theMarkNum, 1)
      set the locH of sprite theMarkNum to 11 + (9 * indentNum)
      put "  " into char charsOver of line i of field "SubMenuOff"
      next repeat
    end if
    set the locH of sprite theMarkNum to -1000
  end repeat
  if numLines < subMenuMaxLines then
    repeat with i = numLines + 1 to subMenuMaxLines
      set theMarkNum to i + 3
      puppetSprite(theMarkNum, 1)
      set the locH of sprite theMarkNum to -1000
    end repeat
  end if
  put " " into field "SubMenu"
  updateStage()
  put menuText into field "SubMenu"
end

on stuffMenu theText
  put theText into field "SubMenuOff"
  set the textHeight of field "SubMenu" to subTextHeight
end

on drawHiliteSubMenu whichLine
  set whichCast to SubTextCast
  set whichSprite to SubTextSprite
  puppetSprite(subHiliteSprite, 1)
  set the castNum of sprite subHiliteSprite to subHiliteCast
  set the width of sprite subHiliteSprite to the width of cast whichCast + 9
  set the blend of sprite subHiliteSprite to 30
  set castLines to the number of lines in field whichCast
  set castHeight to the height of cast whichCast
  set lineHeight to castHeight / castLines
  set the height of sprite subHiliteSprite to lineHeight
  set hiliteLocH to the locH of sprite whichSprite - 5
  set hiliteLocV to the locV of sprite whichSprite + (lineHeight * (whichLine - 1))
  set the loc of sprite subHiliteSprite to point(hiliteLocH, hiliteLocV)
  updateStage()
end

on hideHilite doUpdate
  set the locH of sprite subHiliteSprite to -1000
  puppetSprite(subHiliteSprite, 0)
  if doUpdate then
    updateStage()
  end if
end

on cleanupSubMenu
  set numLines to the number of lines in field "SubMenuOff"
  repeat with i = 1 to numLines
    set theMarkNum to i + 3
    set the locH of sprite theMarkNum to -1000
  end repeat
  hideHilite(0)
end

on stuffHelp theHelpList
  set the text of field "General Help" to theHelpList
end

on showHelpText whichHelp
  global lastHelpOff, helpBoxChannel, helpTextChannel, helpMouseLoc, helpTextOn
  if lastHelpOff > the ticks then
    if not (string(whichHelp) contains "mouse") then
      return 0
    end if
  end if
  set xLoc to the mouseH
  set yLoc to the mouseV
  set textXOffset to 2
  set textYOffset to 9
  set generalhelpText to value(field "General Help")
  set helpText to getaProp(generalhelpText, whichHelp)
  set helpBoxCast to subHelpBoxCast
  set helpBoxWidth to the width of cast helpBoxCast
  set helpBoxHeight to the height of cast helpBoxCast
  if (yLoc + helpBoxHeight + 5) >= 335 then
    set helpLocX to xLoc - helpBoxWidth + textXOffset - 1
    set helpLocY to yLoc - helpBoxHeight + textYOffset - 5
  else
    if (xLoc + helpBoxWidth) >= 180 then
      if xLoc > helpBoxWidth then
        set helpLocX to xLoc - helpBoxWidth + 4
      else
        set helpLocX to 180 - helpBoxWidth + 4
      end if
    else
      set helpLocX to xLoc + textXOffset
    end if
    set helpLocY to yLoc + textYOffset
  end if
  set helpLoc to point(helpLocX, helpLocY)
  puppetSprite(helpBoxChannel, 1)
  puppetSprite(helpTextChannel, 1)
  set the castNum of sprite helpBoxChannel to helpBoxCast
  put helpText into field "Status Bar"
  set the loc of sprite helpBoxChannel to helpLoc
  set the loc of sprite helpTextChannel to helpLoc
  set helpMouseLoc to point(xLoc + subLeft, yLoc + subTop)
  set helpTextOn to 2
  updateStage()
end

on subhideHelpText
  global helpBoxChannel, helpTextChannel, helpTextOn, lastHelpOff, helpMouseLoc, helpDelayTicks
  set the locH of sprite helpBoxChannel to -1000
  set the locH of sprite helpTextChannel to -1000
  updateStage()
  puppetSprite(helpBoxChannel, 0)
  puppetSprite(helpTextChannel, 0)
  set helpTextOn to 0
  set helpMouseLoc to 0
  set lastHelpOff to the ticks + helpDelayTicks
end

on showSprites
  set aList to [:]
  repeat with i = 1 to 48
    addProp(aList, i, the puppet of sprite i)
  end repeat
  put aList
end
